package com.ruoyi.system.domain.visit.dr;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public class VisitDrCheckHistoryExample implements Serializable {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private static final long serialVersionUID = 1L;

    public VisitDrCheckHistoryExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria implements Serializable {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andRuleIdIsNull() {
            addCriterion("rule_id is null");
            return (Criteria) this;
        }

        public Criteria andRuleIdIsNotNull() {
            addCriterion("rule_id is not null");
            return (Criteria) this;
        }

        public Criteria andRuleIdEqualTo(String value) {
            addCriterion("rule_id =", value, "ruleId");
            return (Criteria) this;
        }

        public Criteria andRuleIdNotEqualTo(String value) {
            addCriterion("rule_id <>", value, "ruleId");
            return (Criteria) this;
        }

        public Criteria andRuleIdGreaterThan(String value) {
            addCriterion("rule_id >", value, "ruleId");
            return (Criteria) this;
        }

        public Criteria andRuleIdGreaterThanOrEqualTo(String value) {
            addCriterion("rule_id >=", value, "ruleId");
            return (Criteria) this;
        }

        public Criteria andRuleIdLessThan(String value) {
            addCriterion("rule_id <", value, "ruleId");
            return (Criteria) this;
        }

        public Criteria andRuleIdLessThanOrEqualTo(String value) {
            addCriterion("rule_id <=", value, "ruleId");
            return (Criteria) this;
        }

        public Criteria andRuleIdLike(String value) {
            addCriterion("rule_id like", value, "ruleId");
            return (Criteria) this;
        }

        public Criteria andRuleIdNotLike(String value) {
            addCriterion("rule_id not like", value, "ruleId");
            return (Criteria) this;
        }

        public Criteria andRuleIdIn(List<String> values) {
            addCriterion("rule_id in", values, "ruleId");
            return (Criteria) this;
        }

        public Criteria andRuleIdNotIn(List<String> values) {
            addCriterion("rule_id not in", values, "ruleId");
            return (Criteria) this;
        }

        public Criteria andRuleIdBetween(String value1, String value2) {
            addCriterion("rule_id between", value1, value2, "ruleId");
            return (Criteria) this;
        }

        public Criteria andRuleIdNotBetween(String value1, String value2) {
            addCriterion("rule_id not between", value1, value2, "ruleId");
            return (Criteria) this;
        }

        public Criteria andTaskIdIsNull() {
            addCriterion("task_id is null");
            return (Criteria) this;
        }

        public Criteria andTaskIdIsNotNull() {
            addCriterion("task_id is not null");
            return (Criteria) this;
        }

        public Criteria andTaskIdEqualTo(String value) {
            addCriterion("task_id =", value, "taskId");
            return (Criteria) this;
        }

        public Criteria andTaskIdNotEqualTo(String value) {
            addCriterion("task_id <>", value, "taskId");
            return (Criteria) this;
        }

        public Criteria andTaskIdGreaterThan(String value) {
            addCriterion("task_id >", value, "taskId");
            return (Criteria) this;
        }

        public Criteria andTaskIdGreaterThanOrEqualTo(String value) {
            addCriterion("task_id >=", value, "taskId");
            return (Criteria) this;
        }

        public Criteria andTaskIdLessThan(String value) {
            addCriterion("task_id <", value, "taskId");
            return (Criteria) this;
        }

        public Criteria andTaskIdLessThanOrEqualTo(String value) {
            addCriterion("task_id <=", value, "taskId");
            return (Criteria) this;
        }

        public Criteria andTaskIdLike(String value) {
            addCriterion("task_id like", value, "taskId");
            return (Criteria) this;
        }

        public Criteria andTaskIdNotLike(String value) {
            addCriterion("task_id not like", value, "taskId");
            return (Criteria) this;
        }

        public Criteria andTaskIdIn(List<String> values) {
            addCriterion("task_id in", values, "taskId");
            return (Criteria) this;
        }

        public Criteria andTaskIdNotIn(List<String> values) {
            addCriterion("task_id not in", values, "taskId");
            return (Criteria) this;
        }

        public Criteria andTaskIdBetween(String value1, String value2) {
            addCriterion("task_id between", value1, value2, "taskId");
            return (Criteria) this;
        }

        public Criteria andTaskIdNotBetween(String value1, String value2) {
            addCriterion("task_id not between", value1, value2, "taskId");
            return (Criteria) this;
        }

        public Criteria andTitleIsNull() {
            addCriterion("title is null");
            return (Criteria) this;
        }

        public Criteria andTitleIsNotNull() {
            addCriterion("title is not null");
            return (Criteria) this;
        }

        public Criteria andTitleEqualTo(String value) {
            addCriterion("title =", value, "title");
            return (Criteria) this;
        }

        public Criteria andTitleNotEqualTo(String value) {
            addCriterion("title <>", value, "title");
            return (Criteria) this;
        }

        public Criteria andTitleGreaterThan(String value) {
            addCriterion("title >", value, "title");
            return (Criteria) this;
        }

        public Criteria andTitleGreaterThanOrEqualTo(String value) {
            addCriterion("title >=", value, "title");
            return (Criteria) this;
        }

        public Criteria andTitleLessThan(String value) {
            addCriterion("title <", value, "title");
            return (Criteria) this;
        }

        public Criteria andTitleLessThanOrEqualTo(String value) {
            addCriterion("title <=", value, "title");
            return (Criteria) this;
        }

        public Criteria andTitleLike(String value) {
            addCriterion("title like", value, "title");
            return (Criteria) this;
        }

        public Criteria andTitleNotLike(String value) {
            addCriterion("title not like", value, "title");
            return (Criteria) this;
        }

        public Criteria andTitleIn(List<String> values) {
            addCriterion("title in", values, "title");
            return (Criteria) this;
        }

        public Criteria andTitleNotIn(List<String> values) {
            addCriterion("title not in", values, "title");
            return (Criteria) this;
        }

        public Criteria andTitleBetween(String value1, String value2) {
            addCriterion("title between", value1, value2, "title");
            return (Criteria) this;
        }

        public Criteria andTitleNotBetween(String value1, String value2) {
            addCriterion("title not between", value1, value2, "title");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIsNull() {
            addCriterion("company_id is null");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIsNotNull() {
            addCriterion("company_id is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyIdEqualTo(String value) {
            addCriterion("company_id =", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotEqualTo(String value) {
            addCriterion("company_id <>", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdGreaterThan(String value) {
            addCriterion("company_id >", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdGreaterThanOrEqualTo(String value) {
            addCriterion("company_id >=", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLessThan(String value) {
            addCriterion("company_id <", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLessThanOrEqualTo(String value) {
            addCriterion("company_id <=", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLike(String value) {
            addCriterion("company_id like", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotLike(String value) {
            addCriterion("company_id not like", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIn(List<String> values) {
            addCriterion("company_id in", values, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotIn(List<String> values) {
            addCriterion("company_id not in", values, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdBetween(String value1, String value2) {
            addCriterion("company_id between", value1, value2, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotBetween(String value1, String value2) {
            addCriterion("company_id not between", value1, value2, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIsNull() {
            addCriterion("company_name is null");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIsNotNull() {
            addCriterion("company_name is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyNameEqualTo(String value) {
            addCriterion("company_name =", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotEqualTo(String value) {
            addCriterion("company_name <>", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameGreaterThan(String value) {
            addCriterion("company_name >", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameGreaterThanOrEqualTo(String value) {
            addCriterion("company_name >=", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLessThan(String value) {
            addCriterion("company_name <", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLessThanOrEqualTo(String value) {
            addCriterion("company_name <=", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLike(String value) {
            addCriterion("company_name like", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotLike(String value) {
            addCriterion("company_name not like", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIn(List<String> values) {
            addCriterion("company_name in", values, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotIn(List<String> values) {
            addCriterion("company_name not in", values, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameBetween(String value1, String value2) {
            addCriterion("company_name between", value1, value2, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotBetween(String value1, String value2) {
            addCriterion("company_name not between", value1, value2, "companyName");
            return (Criteria) this;
        }

        public Criteria andZhCreditLevelIsNull() {
            addCriterion("zh_credit_level is null");
            return (Criteria) this;
        }

        public Criteria andZhCreditLevelIsNotNull() {
            addCriterion("zh_credit_level is not null");
            return (Criteria) this;
        }

        public Criteria andZhCreditLevelEqualTo(String value) {
            addCriterion("zh_credit_level =", value, "zhCreditLevel");
            return (Criteria) this;
        }

        public Criteria andZhCreditLevelNotEqualTo(String value) {
            addCriterion("zh_credit_level <>", value, "zhCreditLevel");
            return (Criteria) this;
        }

        public Criteria andZhCreditLevelGreaterThan(String value) {
            addCriterion("zh_credit_level >", value, "zhCreditLevel");
            return (Criteria) this;
        }

        public Criteria andZhCreditLevelGreaterThanOrEqualTo(String value) {
            addCriterion("zh_credit_level >=", value, "zhCreditLevel");
            return (Criteria) this;
        }

        public Criteria andZhCreditLevelLessThan(String value) {
            addCriterion("zh_credit_level <", value, "zhCreditLevel");
            return (Criteria) this;
        }

        public Criteria andZhCreditLevelLessThanOrEqualTo(String value) {
            addCriterion("zh_credit_level <=", value, "zhCreditLevel");
            return (Criteria) this;
        }

        public Criteria andZhCreditLevelLike(String value) {
            addCriterion("zh_credit_level like", value, "zhCreditLevel");
            return (Criteria) this;
        }

        public Criteria andZhCreditLevelNotLike(String value) {
            addCriterion("zh_credit_level not like", value, "zhCreditLevel");
            return (Criteria) this;
        }

        public Criteria andZhCreditLevelIn(List<String> values) {
            addCriterion("zh_credit_level in", values, "zhCreditLevel");
            return (Criteria) this;
        }

        public Criteria andZhCreditLevelNotIn(List<String> values) {
            addCriterion("zh_credit_level not in", values, "zhCreditLevel");
            return (Criteria) this;
        }

        public Criteria andZhCreditLevelBetween(String value1, String value2) {
            addCriterion("zh_credit_level between", value1, value2, "zhCreditLevel");
            return (Criteria) this;
        }

        public Criteria andZhCreditLevelNotBetween(String value1, String value2) {
            addCriterion("zh_credit_level not between", value1, value2, "zhCreditLevel");
            return (Criteria) this;
        }

        public Criteria andChooseTypeIsNull() {
            addCriterion("choose_type is null");
            return (Criteria) this;
        }

        public Criteria andChooseTypeIsNotNull() {
            addCriterion("choose_type is not null");
            return (Criteria) this;
        }

        public Criteria andChooseTypeEqualTo(String value) {
            addCriterion("choose_type =", value, "chooseType");
            return (Criteria) this;
        }

        public Criteria andChooseTypeNotEqualTo(String value) {
            addCriterion("choose_type <>", value, "chooseType");
            return (Criteria) this;
        }

        public Criteria andChooseTypeGreaterThan(String value) {
            addCriterion("choose_type >", value, "chooseType");
            return (Criteria) this;
        }

        public Criteria andChooseTypeGreaterThanOrEqualTo(String value) {
            addCriterion("choose_type >=", value, "chooseType");
            return (Criteria) this;
        }

        public Criteria andChooseTypeLessThan(String value) {
            addCriterion("choose_type <", value, "chooseType");
            return (Criteria) this;
        }

        public Criteria andChooseTypeLessThanOrEqualTo(String value) {
            addCriterion("choose_type <=", value, "chooseType");
            return (Criteria) this;
        }

        public Criteria andChooseTypeLike(String value) {
            addCriterion("choose_type like", value, "chooseType");
            return (Criteria) this;
        }

        public Criteria andChooseTypeNotLike(String value) {
            addCriterion("choose_type not like", value, "chooseType");
            return (Criteria) this;
        }

        public Criteria andChooseTypeIn(List<String> values) {
            addCriterion("choose_type in", values, "chooseType");
            return (Criteria) this;
        }

        public Criteria andChooseTypeNotIn(List<String> values) {
            addCriterion("choose_type not in", values, "chooseType");
            return (Criteria) this;
        }

        public Criteria andChooseTypeBetween(String value1, String value2) {
            addCriterion("choose_type between", value1, value2, "chooseType");
            return (Criteria) this;
        }

        public Criteria andChooseTypeNotBetween(String value1, String value2) {
            addCriterion("choose_type not between", value1, value2, "chooseType");
            return (Criteria) this;
        }

        public Criteria andChooseFormIsNull() {
            addCriterion("choose_form is null");
            return (Criteria) this;
        }

        public Criteria andChooseFormIsNotNull() {
            addCriterion("choose_form is not null");
            return (Criteria) this;
        }

        public Criteria andChooseFormEqualTo(String value) {
            addCriterion("choose_form =", value, "chooseForm");
            return (Criteria) this;
        }

        public Criteria andChooseFormNotEqualTo(String value) {
            addCriterion("choose_form <>", value, "chooseForm");
            return (Criteria) this;
        }

        public Criteria andChooseFormGreaterThan(String value) {
            addCriterion("choose_form >", value, "chooseForm");
            return (Criteria) this;
        }

        public Criteria andChooseFormGreaterThanOrEqualTo(String value) {
            addCriterion("choose_form >=", value, "chooseForm");
            return (Criteria) this;
        }

        public Criteria andChooseFormLessThan(String value) {
            addCriterion("choose_form <", value, "chooseForm");
            return (Criteria) this;
        }

        public Criteria andChooseFormLessThanOrEqualTo(String value) {
            addCriterion("choose_form <=", value, "chooseForm");
            return (Criteria) this;
        }

        public Criteria andChooseFormLike(String value) {
            addCriterion("choose_form like", value, "chooseForm");
            return (Criteria) this;
        }

        public Criteria andChooseFormNotLike(String value) {
            addCriterion("choose_form not like", value, "chooseForm");
            return (Criteria) this;
        }

        public Criteria andChooseFormIn(List<String> values) {
            addCriterion("choose_form in", values, "chooseForm");
            return (Criteria) this;
        }

        public Criteria andChooseFormNotIn(List<String> values) {
            addCriterion("choose_form not in", values, "chooseForm");
            return (Criteria) this;
        }

        public Criteria andChooseFormBetween(String value1, String value2) {
            addCriterion("choose_form between", value1, value2, "chooseForm");
            return (Criteria) this;
        }

        public Criteria andChooseFormNotBetween(String value1, String value2) {
            addCriterion("choose_form not between", value1, value2, "chooseForm");
            return (Criteria) this;
        }

        public Criteria andChooseTimeIsNull() {
            addCriterion("choose_time is null");
            return (Criteria) this;
        }

        public Criteria andChooseTimeIsNotNull() {
            addCriterion("choose_time is not null");
            return (Criteria) this;
        }

        public Criteria andChooseTimeEqualTo(String value) {
            addCriterion("choose_time =", value, "chooseTime");
            return (Criteria) this;
        }

        public Criteria andChooseTimeNotEqualTo(String value) {
            addCriterion("choose_time <>", value, "chooseTime");
            return (Criteria) this;
        }

        public Criteria andChooseTimeGreaterThan(String value) {
            addCriterion("choose_time >", value, "chooseTime");
            return (Criteria) this;
        }

        public Criteria andChooseTimeGreaterThanOrEqualTo(String value) {
            addCriterion("choose_time >=", value, "chooseTime");
            return (Criteria) this;
        }

        public Criteria andChooseTimeLessThan(String value) {
            addCriterion("choose_time <", value, "chooseTime");
            return (Criteria) this;
        }

        public Criteria andChooseTimeLessThanOrEqualTo(String value) {
            addCriterion("choose_time <=", value, "chooseTime");
            return (Criteria) this;
        }

        public Criteria andChooseTimeLike(String value) {
            addCriterion("choose_time like", value, "chooseTime");
            return (Criteria) this;
        }

        public Criteria andChooseTimeNotLike(String value) {
            addCriterion("choose_time not like", value, "chooseTime");
            return (Criteria) this;
        }

        public Criteria andChooseTimeIn(List<String> values) {
            addCriterion("choose_time in", values, "chooseTime");
            return (Criteria) this;
        }

        public Criteria andChooseTimeNotIn(List<String> values) {
            addCriterion("choose_time not in", values, "chooseTime");
            return (Criteria) this;
        }

        public Criteria andChooseTimeBetween(String value1, String value2) {
            addCriterion("choose_time between", value1, value2, "chooseTime");
            return (Criteria) this;
        }

        public Criteria andChooseTimeNotBetween(String value1, String value2) {
            addCriterion("choose_time not between", value1, value2, "chooseTime");
            return (Criteria) this;
        }

        public Criteria andResultIsNull() {
            addCriterion("result is null");
            return (Criteria) this;
        }

        public Criteria andResultIsNotNull() {
            addCriterion("result is not null");
            return (Criteria) this;
        }

        public Criteria andResultEqualTo(String value) {
            addCriterion("result =", value, "result");
            return (Criteria) this;
        }

        public Criteria andResultNotEqualTo(String value) {
            addCriterion("result <>", value, "result");
            return (Criteria) this;
        }

        public Criteria andResultGreaterThan(String value) {
            addCriterion("result >", value, "result");
            return (Criteria) this;
        }

        public Criteria andResultGreaterThanOrEqualTo(String value) {
            addCriterion("result >=", value, "result");
            return (Criteria) this;
        }

        public Criteria andResultLessThan(String value) {
            addCriterion("result <", value, "result");
            return (Criteria) this;
        }

        public Criteria andResultLessThanOrEqualTo(String value) {
            addCriterion("result <=", value, "result");
            return (Criteria) this;
        }

        public Criteria andResultLike(String value) {
            addCriterion("result like", value, "result");
            return (Criteria) this;
        }

        public Criteria andResultNotLike(String value) {
            addCriterion("result not like", value, "result");
            return (Criteria) this;
        }

        public Criteria andResultIn(List<String> values) {
            addCriterion("result in", values, "result");
            return (Criteria) this;
        }

        public Criteria andResultNotIn(List<String> values) {
            addCriterion("result not in", values, "result");
            return (Criteria) this;
        }

        public Criteria andResultBetween(String value1, String value2) {
            addCriterion("result between", value1, value2, "result");
            return (Criteria) this;
        }

        public Criteria andResultNotBetween(String value1, String value2) {
            addCriterion("result not between", value1, value2, "result");
            return (Criteria) this;
        }

        public Criteria andTaskUserIdsIsNull() {
            addCriterion("task_user_ids is null");
            return (Criteria) this;
        }

        public Criteria andTaskUserIdsIsNotNull() {
            addCriterion("task_user_ids is not null");
            return (Criteria) this;
        }

        public Criteria andTaskUserIdsEqualTo(String value) {
            addCriterion("task_user_ids =", value, "taskUserIds");
            return (Criteria) this;
        }

        public Criteria andTaskUserIdsNotEqualTo(String value) {
            addCriterion("task_user_ids <>", value, "taskUserIds");
            return (Criteria) this;
        }

        public Criteria andTaskUserIdsGreaterThan(String value) {
            addCriterion("task_user_ids >", value, "taskUserIds");
            return (Criteria) this;
        }

        public Criteria andTaskUserIdsGreaterThanOrEqualTo(String value) {
            addCriterion("task_user_ids >=", value, "taskUserIds");
            return (Criteria) this;
        }

        public Criteria andTaskUserIdsLessThan(String value) {
            addCriterion("task_user_ids <", value, "taskUserIds");
            return (Criteria) this;
        }

        public Criteria andTaskUserIdsLessThanOrEqualTo(String value) {
            addCriterion("task_user_ids <=", value, "taskUserIds");
            return (Criteria) this;
        }

        public Criteria andTaskUserIdsLike(String value) {
            addCriterion("task_user_ids like", value, "taskUserIds");
            return (Criteria) this;
        }

        public Criteria andTaskUserIdsNotLike(String value) {
            addCriterion("task_user_ids not like", value, "taskUserIds");
            return (Criteria) this;
        }

        public Criteria andTaskUserIdsIn(List<String> values) {
            addCriterion("task_user_ids in", values, "taskUserIds");
            return (Criteria) this;
        }

        public Criteria andTaskUserIdsNotIn(List<String> values) {
            addCriterion("task_user_ids not in", values, "taskUserIds");
            return (Criteria) this;
        }

        public Criteria andTaskUserIdsBetween(String value1, String value2) {
            addCriterion("task_user_ids between", value1, value2, "taskUserIds");
            return (Criteria) this;
        }

        public Criteria andTaskUserIdsNotBetween(String value1, String value2) {
            addCriterion("task_user_ids not between", value1, value2, "taskUserIds");
            return (Criteria) this;
        }

        public Criteria andTaskUsersIsNull() {
            addCriterion("task_users is null");
            return (Criteria) this;
        }

        public Criteria andTaskUsersIsNotNull() {
            addCriterion("task_users is not null");
            return (Criteria) this;
        }

        public Criteria andTaskUsersEqualTo(String value) {
            addCriterion("task_users =", value, "taskUsers");
            return (Criteria) this;
        }

        public Criteria andTaskUsersNotEqualTo(String value) {
            addCriterion("task_users <>", value, "taskUsers");
            return (Criteria) this;
        }

        public Criteria andTaskUsersGreaterThan(String value) {
            addCriterion("task_users >", value, "taskUsers");
            return (Criteria) this;
        }

        public Criteria andTaskUsersGreaterThanOrEqualTo(String value) {
            addCriterion("task_users >=", value, "taskUsers");
            return (Criteria) this;
        }

        public Criteria andTaskUsersLessThan(String value) {
            addCriterion("task_users <", value, "taskUsers");
            return (Criteria) this;
        }

        public Criteria andTaskUsersLessThanOrEqualTo(String value) {
            addCriterion("task_users <=", value, "taskUsers");
            return (Criteria) this;
        }

        public Criteria andTaskUsersLike(String value) {
            addCriterion("task_users like", value, "taskUsers");
            return (Criteria) this;
        }

        public Criteria andTaskUsersNotLike(String value) {
            addCriterion("task_users not like", value, "taskUsers");
            return (Criteria) this;
        }

        public Criteria andTaskUsersIn(List<String> values) {
            addCriterion("task_users in", values, "taskUsers");
            return (Criteria) this;
        }

        public Criteria andTaskUsersNotIn(List<String> values) {
            addCriterion("task_users not in", values, "taskUsers");
            return (Criteria) this;
        }

        public Criteria andTaskUsersBetween(String value1, String value2) {
            addCriterion("task_users between", value1, value2, "taskUsers");
            return (Criteria) this;
        }

        public Criteria andTaskUsersNotBetween(String value1, String value2) {
            addCriterion("task_users not between", value1, value2, "taskUsers");
            return (Criteria) this;
        }

        public Criteria andCheckedObjectIsNull() {
            addCriterion("checked_object is null");
            return (Criteria) this;
        }

        public Criteria andCheckedObjectIsNotNull() {
            addCriterion("checked_object is not null");
            return (Criteria) this;
        }

        public Criteria andCheckedObjectEqualTo(String value) {
            addCriterion("checked_object =", value, "checkedObject");
            return (Criteria) this;
        }

        public Criteria andCheckedObjectNotEqualTo(String value) {
            addCriterion("checked_object <>", value, "checkedObject");
            return (Criteria) this;
        }

        public Criteria andCheckedObjectGreaterThan(String value) {
            addCriterion("checked_object >", value, "checkedObject");
            return (Criteria) this;
        }

        public Criteria andCheckedObjectGreaterThanOrEqualTo(String value) {
            addCriterion("checked_object >=", value, "checkedObject");
            return (Criteria) this;
        }

        public Criteria andCheckedObjectLessThan(String value) {
            addCriterion("checked_object <", value, "checkedObject");
            return (Criteria) this;
        }

        public Criteria andCheckedObjectLessThanOrEqualTo(String value) {
            addCriterion("checked_object <=", value, "checkedObject");
            return (Criteria) this;
        }

        public Criteria andCheckedObjectLike(String value) {
            addCriterion("checked_object like", value, "checkedObject");
            return (Criteria) this;
        }

        public Criteria andCheckedObjectNotLike(String value) {
            addCriterion("checked_object not like", value, "checkedObject");
            return (Criteria) this;
        }

        public Criteria andCheckedObjectIn(List<String> values) {
            addCriterion("checked_object in", values, "checkedObject");
            return (Criteria) this;
        }

        public Criteria andCheckedObjectNotIn(List<String> values) {
            addCriterion("checked_object not in", values, "checkedObject");
            return (Criteria) this;
        }

        public Criteria andCheckedObjectBetween(String value1, String value2) {
            addCriterion("checked_object between", value1, value2, "checkedObject");
            return (Criteria) this;
        }

        public Criteria andCheckedObjectNotBetween(String value1, String value2) {
            addCriterion("checked_object not between", value1, value2, "checkedObject");
            return (Criteria) this;
        }

        public Criteria andTelephoneIsNull() {
            addCriterion("telephone is null");
            return (Criteria) this;
        }

        public Criteria andTelephoneIsNotNull() {
            addCriterion("telephone is not null");
            return (Criteria) this;
        }

        public Criteria andTelephoneEqualTo(String value) {
            addCriterion("telephone =", value, "telephone");
            return (Criteria) this;
        }

        public Criteria andTelephoneNotEqualTo(String value) {
            addCriterion("telephone <>", value, "telephone");
            return (Criteria) this;
        }

        public Criteria andTelephoneGreaterThan(String value) {
            addCriterion("telephone >", value, "telephone");
            return (Criteria) this;
        }

        public Criteria andTelephoneGreaterThanOrEqualTo(String value) {
            addCriterion("telephone >=", value, "telephone");
            return (Criteria) this;
        }

        public Criteria andTelephoneLessThan(String value) {
            addCriterion("telephone <", value, "telephone");
            return (Criteria) this;
        }

        public Criteria andTelephoneLessThanOrEqualTo(String value) {
            addCriterion("telephone <=", value, "telephone");
            return (Criteria) this;
        }

        public Criteria andTelephoneLike(String value) {
            addCriterion("telephone like", value, "telephone");
            return (Criteria) this;
        }

        public Criteria andTelephoneNotLike(String value) {
            addCriterion("telephone not like", value, "telephone");
            return (Criteria) this;
        }

        public Criteria andTelephoneIn(List<String> values) {
            addCriterion("telephone in", values, "telephone");
            return (Criteria) this;
        }

        public Criteria andTelephoneNotIn(List<String> values) {
            addCriterion("telephone not in", values, "telephone");
            return (Criteria) this;
        }

        public Criteria andTelephoneBetween(String value1, String value2) {
            addCriterion("telephone between", value1, value2, "telephone");
            return (Criteria) this;
        }

        public Criteria andTelephoneNotBetween(String value1, String value2) {
            addCriterion("telephone not between", value1, value2, "telephone");
            return (Criteria) this;
        }

        public Criteria andAddressIsNull() {
            addCriterion("address is null");
            return (Criteria) this;
        }

        public Criteria andAddressIsNotNull() {
            addCriterion("address is not null");
            return (Criteria) this;
        }

        public Criteria andAddressEqualTo(String value) {
            addCriterion("address =", value, "address");
            return (Criteria) this;
        }

        public Criteria andAddressNotEqualTo(String value) {
            addCriterion("address <>", value, "address");
            return (Criteria) this;
        }

        public Criteria andAddressGreaterThan(String value) {
            addCriterion("address >", value, "address");
            return (Criteria) this;
        }

        public Criteria andAddressGreaterThanOrEqualTo(String value) {
            addCriterion("address >=", value, "address");
            return (Criteria) this;
        }

        public Criteria andAddressLessThan(String value) {
            addCriterion("address <", value, "address");
            return (Criteria) this;
        }

        public Criteria andAddressLessThanOrEqualTo(String value) {
            addCriterion("address <=", value, "address");
            return (Criteria) this;
        }

        public Criteria andAddressLike(String value) {
            addCriterion("address like", value, "address");
            return (Criteria) this;
        }

        public Criteria andAddressNotLike(String value) {
            addCriterion("address not like", value, "address");
            return (Criteria) this;
        }

        public Criteria andAddressIn(List<String> values) {
            addCriterion("address in", values, "address");
            return (Criteria) this;
        }

        public Criteria andAddressNotIn(List<String> values) {
            addCriterion("address not in", values, "address");
            return (Criteria) this;
        }

        public Criteria andAddressBetween(String value1, String value2) {
            addCriterion("address between", value1, value2, "address");
            return (Criteria) this;
        }

        public Criteria andAddressNotBetween(String value1, String value2) {
            addCriterion("address not between", value1, value2, "address");
            return (Criteria) this;
        }

        public Criteria andCheckTimeIsNull() {
            addCriterion("check_time is null");
            return (Criteria) this;
        }

        public Criteria andCheckTimeIsNotNull() {
            addCriterion("check_time is not null");
            return (Criteria) this;
        }

        public Criteria andCheckTimeEqualTo(String value) {
            addCriterion("check_time =", value, "checkTime");
            return (Criteria) this;
        }

        public Criteria andCheckTimeNotEqualTo(String value) {
            addCriterion("check_time <>", value, "checkTime");
            return (Criteria) this;
        }

        public Criteria andCheckTimeGreaterThan(String value) {
            addCriterion("check_time >", value, "checkTime");
            return (Criteria) this;
        }

        public Criteria andCheckTimeGreaterThanOrEqualTo(String value) {
            addCriterion("check_time >=", value, "checkTime");
            return (Criteria) this;
        }

        public Criteria andCheckTimeLessThan(String value) {
            addCriterion("check_time <", value, "checkTime");
            return (Criteria) this;
        }

        public Criteria andCheckTimeLessThanOrEqualTo(String value) {
            addCriterion("check_time <=", value, "checkTime");
            return (Criteria) this;
        }

        public Criteria andCheckTimeLike(String value) {
            addCriterion("check_time like", value, "checkTime");
            return (Criteria) this;
        }

        public Criteria andCheckTimeNotLike(String value) {
            addCriterion("check_time not like", value, "checkTime");
            return (Criteria) this;
        }

        public Criteria andCheckTimeIn(List<String> values) {
            addCriterion("check_time in", values, "checkTime");
            return (Criteria) this;
        }

        public Criteria andCheckTimeNotIn(List<String> values) {
            addCriterion("check_time not in", values, "checkTime");
            return (Criteria) this;
        }

        public Criteria andCheckTimeBetween(String value1, String value2) {
            addCriterion("check_time between", value1, value2, "checkTime");
            return (Criteria) this;
        }

        public Criteria andCheckTimeNotBetween(String value1, String value2) {
            addCriterion("check_time not between", value1, value2, "checkTime");
            return (Criteria) this;
        }

        public Criteria andCheckUsersIsNull() {
            addCriterion("check_users is null");
            return (Criteria) this;
        }

        public Criteria andCheckUsersIsNotNull() {
            addCriterion("check_users is not null");
            return (Criteria) this;
        }

        public Criteria andCheckUsersEqualTo(String value) {
            addCriterion("check_users =", value, "checkUsers");
            return (Criteria) this;
        }

        public Criteria andCheckUsersNotEqualTo(String value) {
            addCriterion("check_users <>", value, "checkUsers");
            return (Criteria) this;
        }

        public Criteria andCheckUsersGreaterThan(String value) {
            addCriterion("check_users >", value, "checkUsers");
            return (Criteria) this;
        }

        public Criteria andCheckUsersGreaterThanOrEqualTo(String value) {
            addCriterion("check_users >=", value, "checkUsers");
            return (Criteria) this;
        }

        public Criteria andCheckUsersLessThan(String value) {
            addCriterion("check_users <", value, "checkUsers");
            return (Criteria) this;
        }

        public Criteria andCheckUsersLessThanOrEqualTo(String value) {
            addCriterion("check_users <=", value, "checkUsers");
            return (Criteria) this;
        }

        public Criteria andCheckUsersLike(String value) {
            addCriterion("check_users like", value, "checkUsers");
            return (Criteria) this;
        }

        public Criteria andCheckUsersNotLike(String value) {
            addCriterion("check_users not like", value, "checkUsers");
            return (Criteria) this;
        }

        public Criteria andCheckUsersIn(List<String> values) {
            addCriterion("check_users in", values, "checkUsers");
            return (Criteria) this;
        }

        public Criteria andCheckUsersNotIn(List<String> values) {
            addCriterion("check_users not in", values, "checkUsers");
            return (Criteria) this;
        }

        public Criteria andCheckUsersBetween(String value1, String value2) {
            addCriterion("check_users between", value1, value2, "checkUsers");
            return (Criteria) this;
        }

        public Criteria andCheckUsersNotBetween(String value1, String value2) {
            addCriterion("check_users not between", value1, value2, "checkUsers");
            return (Criteria) this;
        }

        public Criteria andCreateByIsNull() {
            addCriterion("create_by is null");
            return (Criteria) this;
        }

        public Criteria andCreateByIsNotNull() {
            addCriterion("create_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreateByEqualTo(String value) {
            addCriterion("create_by =", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotEqualTo(String value) {
            addCriterion("create_by <>", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByGreaterThan(String value) {
            addCriterion("create_by >", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByGreaterThanOrEqualTo(String value) {
            addCriterion("create_by >=", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLessThan(String value) {
            addCriterion("create_by <", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLessThanOrEqualTo(String value) {
            addCriterion("create_by <=", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLike(String value) {
            addCriterion("create_by like", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotLike(String value) {
            addCriterion("create_by not like", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByIn(List<String> values) {
            addCriterion("create_by in", values, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotIn(List<String> values) {
            addCriterion("create_by not in", values, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByBetween(String value1, String value2) {
            addCriterion("create_by between", value1, value2, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotBetween(String value1, String value2) {
            addCriterion("create_by not between", value1, value2, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(String value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(String value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(String value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(String value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(String value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(String value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLike(String value) {
            addCriterion("create_time like", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotLike(String value) {
            addCriterion("create_time not like", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<String> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<String> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(String value1, String value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(String value1, String value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneIsNull() {
            addCriterion("extfield_one is null");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneIsNotNull() {
            addCriterion("extfield_one is not null");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneEqualTo(String value) {
            addCriterion("extfield_one =", value, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneNotEqualTo(String value) {
            addCriterion("extfield_one <>", value, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneGreaterThan(String value) {
            addCriterion("extfield_one >", value, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneGreaterThanOrEqualTo(String value) {
            addCriterion("extfield_one >=", value, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneLessThan(String value) {
            addCriterion("extfield_one <", value, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneLessThanOrEqualTo(String value) {
            addCriterion("extfield_one <=", value, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneLike(String value) {
            addCriterion("extfield_one like", value, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneNotLike(String value) {
            addCriterion("extfield_one not like", value, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneIn(List<String> values) {
            addCriterion("extfield_one in", values, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneNotIn(List<String> values) {
            addCriterion("extfield_one not in", values, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneBetween(String value1, String value2) {
            addCriterion("extfield_one between", value1, value2, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldOneNotBetween(String value1, String value2) {
            addCriterion("extfield_one not between", value1, value2, "extfieldOne");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoIsNull() {
            addCriterion("extfield_two is null");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoIsNotNull() {
            addCriterion("extfield_two is not null");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoEqualTo(String value) {
            addCriterion("extfield_two =", value, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoNotEqualTo(String value) {
            addCriterion("extfield_two <>", value, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoGreaterThan(String value) {
            addCriterion("extfield_two >", value, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoGreaterThanOrEqualTo(String value) {
            addCriterion("extfield_two >=", value, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoLessThan(String value) {
            addCriterion("extfield_two <", value, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoLessThanOrEqualTo(String value) {
            addCriterion("extfield_two <=", value, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoLike(String value) {
            addCriterion("extfield_two like", value, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoNotLike(String value) {
            addCriterion("extfield_two not like", value, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoIn(List<String> values) {
            addCriterion("extfield_two in", values, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoNotIn(List<String> values) {
            addCriterion("extfield_two not in", values, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoBetween(String value1, String value2) {
            addCriterion("extfield_two between", value1, value2, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldTwoNotBetween(String value1, String value2) {
            addCriterion("extfield_two not between", value1, value2, "extfieldTwo");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeIsNull() {
            addCriterion("extfield_three is null");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeIsNotNull() {
            addCriterion("extfield_three is not null");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeEqualTo(String value) {
            addCriterion("extfield_three =", value, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeNotEqualTo(String value) {
            addCriterion("extfield_three <>", value, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeGreaterThan(String value) {
            addCriterion("extfield_three >", value, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeGreaterThanOrEqualTo(String value) {
            addCriterion("extfield_three >=", value, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeLessThan(String value) {
            addCriterion("extfield_three <", value, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeLessThanOrEqualTo(String value) {
            addCriterion("extfield_three <=", value, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeLike(String value) {
            addCriterion("extfield_three like", value, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeNotLike(String value) {
            addCriterion("extfield_three not like", value, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeIn(List<String> values) {
            addCriterion("extfield_three in", values, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeNotIn(List<String> values) {
            addCriterion("extfield_three not in", values, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeBetween(String value1, String value2) {
            addCriterion("extfield_three between", value1, value2, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldThreeNotBetween(String value1, String value2) {
            addCriterion("extfield_three not between", value1, value2, "extfieldThree");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourIsNull() {
            addCriterion("extfield_four is null");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourIsNotNull() {
            addCriterion("extfield_four is not null");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourEqualTo(String value) {
            addCriterion("extfield_four =", value, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourNotEqualTo(String value) {
            addCriterion("extfield_four <>", value, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourGreaterThan(String value) {
            addCriterion("extfield_four >", value, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourGreaterThanOrEqualTo(String value) {
            addCriterion("extfield_four >=", value, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourLessThan(String value) {
            addCriterion("extfield_four <", value, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourLessThanOrEqualTo(String value) {
            addCriterion("extfield_four <=", value, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourLike(String value) {
            addCriterion("extfield_four like", value, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourNotLike(String value) {
            addCriterion("extfield_four not like", value, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourIn(List<String> values) {
            addCriterion("extfield_four in", values, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourNotIn(List<String> values) {
            addCriterion("extfield_four not in", values, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourBetween(String value1, String value2) {
            addCriterion("extfield_four between", value1, value2, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFourNotBetween(String value1, String value2) {
            addCriterion("extfield_four not between", value1, value2, "extfieldFour");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveIsNull() {
            addCriterion("extfield_five is null");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveIsNotNull() {
            addCriterion("extfield_five is not null");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveEqualTo(String value) {
            addCriterion("extfield_five =", value, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveNotEqualTo(String value) {
            addCriterion("extfield_five <>", value, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveGreaterThan(String value) {
            addCriterion("extfield_five >", value, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveGreaterThanOrEqualTo(String value) {
            addCriterion("extfield_five >=", value, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveLessThan(String value) {
            addCriterion("extfield_five <", value, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveLessThanOrEqualTo(String value) {
            addCriterion("extfield_five <=", value, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveLike(String value) {
            addCriterion("extfield_five like", value, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveNotLike(String value) {
            addCriterion("extfield_five not like", value, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveIn(List<String> values) {
            addCriterion("extfield_five in", values, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveNotIn(List<String> values) {
            addCriterion("extfield_five not in", values, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveBetween(String value1, String value2) {
            addCriterion("extfield_five between", value1, value2, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldFiveNotBetween(String value1, String value2) {
            addCriterion("extfield_five not between", value1, value2, "extfieldFive");
            return (Criteria) this;
        }

        public Criteria andExtfieldSixIsNull() {
            addCriterion("extfield_six is null");
            return (Criteria) this;
        }

        public Criteria andExtfieldSixIsNotNull() {
            addCriterion("extfield_six is not null");
            return (Criteria) this;
        }

        public Criteria andExtfieldSixEqualTo(String value) {
            addCriterion("extfield_six =", value, "extfieldSix");
            return (Criteria) this;
        }

        public Criteria andExtfieldSixNotEqualTo(String value) {
            addCriterion("extfield_six <>", value, "extfieldSix");
            return (Criteria) this;
        }

        public Criteria andExtfieldSixGreaterThan(String value) {
            addCriterion("extfield_six >", value, "extfieldSix");
            return (Criteria) this;
        }

        public Criteria andExtfieldSixGreaterThanOrEqualTo(String value) {
            addCriterion("extfield_six >=", value, "extfieldSix");
            return (Criteria) this;
        }

        public Criteria andExtfieldSixLessThan(String value) {
            addCriterion("extfield_six <", value, "extfieldSix");
            return (Criteria) this;
        }

        public Criteria andExtfieldSixLessThanOrEqualTo(String value) {
            addCriterion("extfield_six <=", value, "extfieldSix");
            return (Criteria) this;
        }

        public Criteria andExtfieldSixLike(String value) {
            addCriterion("extfield_six like", value, "extfieldSix");
            return (Criteria) this;
        }

        public Criteria andExtfieldSixNotLike(String value) {
            addCriterion("extfield_six not like", value, "extfieldSix");
            return (Criteria) this;
        }

        public Criteria andExtfieldSixIn(List<String> values) {
            addCriterion("extfield_six in", values, "extfieldSix");
            return (Criteria) this;
        }

        public Criteria andExtfieldSixNotIn(List<String> values) {
            addCriterion("extfield_six not in", values, "extfieldSix");
            return (Criteria) this;
        }

        public Criteria andExtfieldSixBetween(String value1, String value2) {
            addCriterion("extfield_six between", value1, value2, "extfieldSix");
            return (Criteria) this;
        }

        public Criteria andExtfieldSixNotBetween(String value1, String value2) {
            addCriterion("extfield_six not between", value1, value2, "extfieldSix");
            return (Criteria) this;
        }

        public Criteria andExtfieldSevenIsNull() {
            addCriterion("extfield_seven is null");
            return (Criteria) this;
        }

        public Criteria andExtfieldSevenIsNotNull() {
            addCriterion("extfield_seven is not null");
            return (Criteria) this;
        }

        public Criteria andExtfieldSevenEqualTo(String value) {
            addCriterion("extfield_seven =", value, "extfieldSeven");
            return (Criteria) this;
        }

        public Criteria andExtfieldSevenNotEqualTo(String value) {
            addCriterion("extfield_seven <>", value, "extfieldSeven");
            return (Criteria) this;
        }

        public Criteria andExtfieldSevenGreaterThan(String value) {
            addCriterion("extfield_seven >", value, "extfieldSeven");
            return (Criteria) this;
        }

        public Criteria andExtfieldSevenGreaterThanOrEqualTo(String value) {
            addCriterion("extfield_seven >=", value, "extfieldSeven");
            return (Criteria) this;
        }

        public Criteria andExtfieldSevenLessThan(String value) {
            addCriterion("extfield_seven <", value, "extfieldSeven");
            return (Criteria) this;
        }

        public Criteria andExtfieldSevenLessThanOrEqualTo(String value) {
            addCriterion("extfield_seven <=", value, "extfieldSeven");
            return (Criteria) this;
        }

        public Criteria andExtfieldSevenLike(String value) {
            addCriterion("extfield_seven like", value, "extfieldSeven");
            return (Criteria) this;
        }

        public Criteria andExtfieldSevenNotLike(String value) {
            addCriterion("extfield_seven not like", value, "extfieldSeven");
            return (Criteria) this;
        }

        public Criteria andExtfieldSevenIn(List<String> values) {
            addCriterion("extfield_seven in", values, "extfieldSeven");
            return (Criteria) this;
        }

        public Criteria andExtfieldSevenNotIn(List<String> values) {
            addCriterion("extfield_seven not in", values, "extfieldSeven");
            return (Criteria) this;
        }

        public Criteria andExtfieldSevenBetween(String value1, String value2) {
            addCriterion("extfield_seven between", value1, value2, "extfieldSeven");
            return (Criteria) this;
        }

        public Criteria andExtfieldSevenNotBetween(String value1, String value2) {
            addCriterion("extfield_seven not between", value1, value2, "extfieldSeven");
            return (Criteria) this;
        }

        public Criteria andExtfieldEightIsNull() {
            addCriterion("extfield_eight is null");
            return (Criteria) this;
        }

        public Criteria andExtfieldEightIsNotNull() {
            addCriterion("extfield_eight is not null");
            return (Criteria) this;
        }

        public Criteria andExtfieldEightEqualTo(String value) {
            addCriterion("extfield_eight =", value, "extfieldEight");
            return (Criteria) this;
        }

        public Criteria andExtfieldEightNotEqualTo(String value) {
            addCriterion("extfield_eight <>", value, "extfieldEight");
            return (Criteria) this;
        }

        public Criteria andExtfieldEightGreaterThan(String value) {
            addCriterion("extfield_eight >", value, "extfieldEight");
            return (Criteria) this;
        }

        public Criteria andExtfieldEightGreaterThanOrEqualTo(String value) {
            addCriterion("extfield_eight >=", value, "extfieldEight");
            return (Criteria) this;
        }

        public Criteria andExtfieldEightLessThan(String value) {
            addCriterion("extfield_eight <", value, "extfieldEight");
            return (Criteria) this;
        }

        public Criteria andExtfieldEightLessThanOrEqualTo(String value) {
            addCriterion("extfield_eight <=", value, "extfieldEight");
            return (Criteria) this;
        }

        public Criteria andExtfieldEightLike(String value) {
            addCriterion("extfield_eight like", value, "extfieldEight");
            return (Criteria) this;
        }

        public Criteria andExtfieldEightNotLike(String value) {
            addCriterion("extfield_eight not like", value, "extfieldEight");
            return (Criteria) this;
        }

        public Criteria andExtfieldEightIn(List<String> values) {
            addCriterion("extfield_eight in", values, "extfieldEight");
            return (Criteria) this;
        }

        public Criteria andExtfieldEightNotIn(List<String> values) {
            addCriterion("extfield_eight not in", values, "extfieldEight");
            return (Criteria) this;
        }

        public Criteria andExtfieldEightBetween(String value1, String value2) {
            addCriterion("extfield_eight between", value1, value2, "extfieldEight");
            return (Criteria) this;
        }

        public Criteria andExtfieldEightNotBetween(String value1, String value2) {
            addCriterion("extfield_eight not between", value1, value2, "extfieldEight");
            return (Criteria) this;
        }

        public Criteria andExtfieldTenIsNull() {
            addCriterion("extfield_ten is null");
            return (Criteria) this;
        }

        public Criteria andExtfieldTenIsNotNull() {
            addCriterion("extfield_ten is not null");
            return (Criteria) this;
        }

        public Criteria andExtfieldTenEqualTo(String value) {
            addCriterion("extfield_ten =", value, "extfieldTen");
            return (Criteria) this;
        }

        public Criteria andExtfieldTenNotEqualTo(String value) {
            addCriterion("extfield_ten <>", value, "extfieldTen");
            return (Criteria) this;
        }

        public Criteria andExtfieldTenGreaterThan(String value) {
            addCriterion("extfield_ten >", value, "extfieldTen");
            return (Criteria) this;
        }

        public Criteria andExtfieldTenGreaterThanOrEqualTo(String value) {
            addCriterion("extfield_ten >=", value, "extfieldTen");
            return (Criteria) this;
        }

        public Criteria andExtfieldTenLessThan(String value) {
            addCriterion("extfield_ten <", value, "extfieldTen");
            return (Criteria) this;
        }

        public Criteria andExtfieldTenLessThanOrEqualTo(String value) {
            addCriterion("extfield_ten <=", value, "extfieldTen");
            return (Criteria) this;
        }

        public Criteria andExtfieldTenLike(String value) {
            addCriterion("extfield_ten like", value, "extfieldTen");
            return (Criteria) this;
        }

        public Criteria andExtfieldTenNotLike(String value) {
            addCriterion("extfield_ten not like", value, "extfieldTen");
            return (Criteria) this;
        }

        public Criteria andExtfieldTenIn(List<String> values) {
            addCriterion("extfield_ten in", values, "extfieldTen");
            return (Criteria) this;
        }

        public Criteria andExtfieldTenNotIn(List<String> values) {
            addCriterion("extfield_ten not in", values, "extfieldTen");
            return (Criteria) this;
        }

        public Criteria andExtfieldTenBetween(String value1, String value2) {
            addCriterion("extfield_ten between", value1, value2, "extfieldTen");
            return (Criteria) this;
        }

        public Criteria andExtfieldTenNotBetween(String value1, String value2) {
            addCriterion("extfield_ten not between", value1, value2, "extfieldTen");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria implements Serializable {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion implements Serializable {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}